%if 0%{?rhel} >= 6
%global debug_package %{nil}
%endif

%global svnrev 702
%global with_ant 1

Name:           piccolo2d
Version:        1.3
Release:        0.svn%{svnrev}.9%{?dist}
Summary:        Structured 2D graphics toolkit

Group:          Development/Libraries
License:        BSD
URL:            http://code.google.com/p/piccolo2d/
# Generated by sh fetch-piccolo2d.sh
Source0:        piccolo2d-1.3-svn%{svnrev}.tar.bz2
Source1:        fetch-piccolo2d.sh
Source2:        %{name}-settings.xml
Source3:        %{name}-build-files.tar.bz2
Patch0:         piccolo2d-pswtpath-getcenter.patch
Patch1:         piccolo2d-pswtimage-dispose.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if !%{with_ant}
BuildRequires:  maven-plugin-bundle
BuildRequires:  maven2-plugin-install >= 2.0.8
BuildRequires:  maven2-plugin-compiler >= 2.0.8
BuildRequires:  maven2-plugin-javadoc >= 2.0.8
BuildRequires:  maven2-plugin-jar >= 2.0.8
BuildRequires:  maven2-plugin-resources >= 2.0.8
BuildRequires:  maven-surefire-maven-plugin 
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-doxia-sitetools
%else
BuildRequires:  ant
%endif
BuildRequires:  java-1.6.0-openjdk-devel
BuildRequires:  eclipse-swt

Requires: eclipse-swt

%if 0%{?rhel} >= 6
ExclusiveArch: i686 x86_64
%else
BuildArch: noarch
%endif

%description
A revolutionary way to create robust, full-featured graphical
applications in Java with striking visual effects such
as zooming, animation and multiple representations.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}

%description javadoc
API documentation for %{name}.

%prep
%setup -q -n piccolo2d.java
%patch0
%patch1

tar xf %{SOURCE3} 

mkdir -p .m2/repository/swt/swt-win32
ln -s %{_libdir}/java/swt.jar .m2/repository/swt/swt-win32.jar

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

cp %{SOURCE2} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
%if !%{with_ant}
mvn-jpp \
        -e \
        -s settings.xml \
        -Dmaven2.jpp.mode=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.skip=true \
        install javadoc:javadoc
%endif
%if %{with_ant}
pushd core
ant -Dmaven.settings.offline=true \
    -Dmaven.test.skip=true \
    -Dmaven.repo.local=.m2/repository \
    package javadoc 
popd
pushd extras
export CLASSPATH=$CLASSPATH:../core/target/piccolo2d-core-1.3-SNAPSHOT.jar
ant -Dmaven.settings.offline=true \
    -Dmaven.test.skip=true \
    -Dmaven.repo.local=.m2/repository \
    package javadoc 
popd
pushd swt
export CLASSPATH=$CLASSPATH:../core/target/piccolo2d-core-1.3-SNAPSHOT.jar:../extras/target/piccolo2d-extras-1.3-SNAPSHOT.jar:%{_libdir}/java/swt.jar
ant -Dmaven.settings.offline=true \
    -Dmaven.test.skip=true \
    -Dmaven.repo.local=.m2/repository \
    package javadoc 
popd
%endif

%install
rm -rf %{buildroot}

# jars
install -d -m 0755 %{buildroot}%{_javadir}/%{name}
install -m 644 core/target/*.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 extras/target/*.jar %{buildroot}%{_javadir}/%{name}/
install -m 644 swt/target/*.jar %{buildroot}%{_javadir}/%{name}/

(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; \
    do ln -sf ${jar} `echo $jar| sed "s|-%{version}-SNAPSHOT||g"`; done)

%if !%{with_ant}
%add_to_maven_depmap org.piccolo2d piccolo2d-parent %{version} JPP piccolo2d-parent
%add_to_maven_depmap org.piccolo2d piccolo2d-core %{version} JPP piccolo2d-core
%add_to_maven_depmap org.piccolo2d piccolo2d-extras %{version} JPP piccolo2d-extras
%add_to_maven_depmap org.piccolo2d piccolo2d-swt %{version} JPP piccolo2d-swt

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -pm 644 parent/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
install -pm 644 core/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-core.pom
install -pm 644 extras/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-extras.pom
install -pm 644 swt/pom.xml \
    %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-swt.pom
%endif

# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{version}
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{version}/core
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{version}/extras
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{version}/swt
cp -pr core/target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{version}/core
cp -pr extras/target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{version}/extras
cp -pr swt/target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{version}/swt
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if !%{with_ant}
%post
%update_maven_depmap

%postun
%update_maven_depmap
%endif

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}
%if !%{with_ant}
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%endif
%doc license-piccolo.txt 

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Fri Feb 12 2010 Andrew Overholt <overholt@redhat.com> 1.3-0.svn702.9
- Don't build debuginfo if building arch-specific packages.

* Fri Feb 05 2010 Andrew Overholt <overholt@redhat.com> 1.3-0.svn702.8
- Don't ship maven files when building with ant.

* Mon Feb 01 2010 Andrew Overholt <overholt@redhat.com> 1.3-0.svn702.7
- Add ant BR when not using maven.

* Mon Feb 01 2010 Andrew Overholt <overholt@redhat.com> 1.3-0.svn702.6
- Only build on x86_64 and x86.

* Mon Feb 1 2010 Alexander Kurtakov <akurtako@redhat.com> 1.3-0.svn702.5
- Build with ant.

* Tue Oct 13 2009 Alexander Kurtakov <akurtako@redhat.com> 1.3-0.svn702.4
- Skip tests.

* Tue Oct 13 2009 Alexander Kurtakov <akurtako@redhat.com> 1.3-0.svn702.3
- New snapshot.
- Add patches needed by pydev.

* Fri Oct 9 2009 Alexander Kurtakov <akurtako@redhat.com> 1.3-0.svn691.2
- Add %%doc.

* Fri Oct 9 2009 Alexander Kurtakov <akurtako@redhat.com> 1.3-0.svn691.1
- Remove umlgraph patch, no longer needed.
- Make fetch script retrieve exact version.

* Fri Oct 9 2009 Alexander Kurtakov <akurtako@redhat.com> 1.3-0.svn689
- Initial package.
